代码随想录算法训练营day19 | LeetCode KMP匹配

kmp匹配算法

今天复习了一下kmp匹配算法,做了一下字符串匹配的题和判断字符串是否由子串重复构成的题,加深了印象。

28. 找出字符串中第一个匹配项的下标
class Solution {
public:
    void getNext(int* next, string s){
        int size = s.size();
        int j=0;
        next[j] = 0;
        for(int i=1; i<size; i++){
            while(s[i] != s[j] && j > 0){
                j = next[j-1];
            }
            if(s[i] == s[j]){
                j++;
            }
            next[i] = j;
        }
    }
    int strStr(string haystack, string needle) {
        int size = needle.size();
        int next[size];
        getNext(next, needle);
        int j=0;
        for(int i=0; i<haystack.size(); i++){
            while(haystack[i] != needle[j] && j>0){
                j = next[j-1];
            }
            if(haystack[i] == needle[j]){
                if(++j == size) return i - size + 1;
            }
        }
        return -1;
    }
};

459. 重复的子字符串

class Solution {
public:
    int* getNext(string s){
        int size = s.size();
        int next[size];
        int j=0;
        next[j] = 0;
        for(int i=1; i<size; i++){
            while(s[i] != s[j] && j>0){
                j = next[j-1];
            }
            if(s[i] == s[j]){
                j++;
            }
            next[i] = j;
        }
        return next;
    }

    bool repeatedSubstringPattern(string s) {
        int* next = getNext(s);
        int size = s.size();
        return size % (size - next[size-1]) == 0 && next[size-1] != 0;
    }
};

第二十二天的算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

_porter

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值